
package org.ululatus.sleepybot;

import java.io.IOException;

public class Main
{
	/**
		Starts a bot
	*/
	public static void runBot( String botScript )
	{
			new Run( botScript );
	}
	
	/**
		Starts a bot with arguments
	*/
	public static void runBot( String[] botScriptAndArgs )
	{
			new Run( botScriptAndArgs );
	}

	/**
		Starts multiple bots
	*/
	public static void runBots( String[] botScripts )
	{
		for ( int i=0; i < botScripts.length; i++ )
		{
			new Run( botScripts[i] );
		}
	}

	/**
		Starts multiple bots with arguments
	*/
	public static void runBots( String[][] botScriptsAndArgs )
	{
		for ( int i=0; i < botScriptsAndArgs.length; i++ )
		{
			new Run( botScriptsAndArgs[i]);
		}
	}
	
	public static void main( String[] args )
	{
		if ( args.length > 0 )
		{
			try
			{
				if ( args.length > 1 )
					new ScriptedBot( args );
				else 
					new ScriptedBot( args[0] );
			}
			catch ( Exception e )
			{
				System.out.println( e.toString() );
				System.exit(1);
			}
		}
		else
		{
			System.out.println("usage: java -jar sleepybot.jar <scriptfilename> or");
			System.out.println("usage: java -jar sleepybot-all.jar <scriptfilename> or");
			System.out.println("usage: java -cp sleepybot.jar;sleep.jar;pircbot.jar org.ululatus.sleepybot.Main <scriptfilename>");
			System.exit(1);
		}
	}
	
	private static class Run implements Runnable
	{
		String botfile;
		String[] args;
		Run( String filename )
		{
			botfile = filename;
			Thread thread = new Thread(this);
			thread.start();
		}

		Run( String[] params )
		{
			botfile = params[0];
			args = params;
			Thread thread = new Thread(this);
			thread.start();
		}
		
		public void run()
		{
			try
			{
				if ( args != null ) {
					new ScriptedBot( args );
				}
				else {
					new ScriptedBot( botfile );
				}
			}
			catch ( Exception e )
			{
				e.printStackTrace();
			}
		}
	}
}
