
package org.ululatus.sleepybot;

import java.util.*;
import java.io.*;
import java.net.*;

import sleep.interfaces.*;
import sleep.runtime.*;
import sleep.bridges.*;
import sleep.parser.ParserConfig;

public class UtilitiesBridge implements Loadable //, Function
{
	static final String newJavaFile = "&newJavaFile";
	static final String isjavafile = "-isjavafile";
	static final String isJavaFile = "&isJavaFile";
	static final String javafileexists = "-javafileexists";
	static final String javaFileExists = "&javaFileExists";
	static final String javaFileLength = "&javaFileLength";
	static final String javaFileGetName = "&javaFileGetName";
	
	static final String javaFileIsDir = "&javaFileIsDir";
	static final String javaFileIsFile = "&javaFileIsFile";
	static final String javaFileCanRead = "&javaFileCanRead";
	static final String javaFileCanWrite = "&javaFileCanWrite";
	static final String javaFileIsHidden = "&javaFileIsHidden";
	static final String javaFileIsAbsolute = "&javaFileIsAbsolute";
	static final String javaFileLastModified = "&javaFileLastModified";
	static final String javaFileGetPath = "&javaFileGetPath";
	static final String javaFileGetParent = "&javaFileGetParent";
	static final String javaFileGetAbsolutePath = "&javaFileGetAbsolutePath";
	static final String javaFileGetCanonicalPath = "&javaFileGetCanonicalPath";
	static final String javaFileGetParentFile = "&javaFileGetParentFile";
	static final String javaFileGetAbsoluteFile = "&javaFileGetAbsoluteFile";
	static final String javaFileGetCanonicalFile = "&javaFileGetCanonicalFile";
	static final String javaFileList = "&javaFileList";
	static final String javaFileListFiles = "&javaFileListFiles";
	static final String javaFileListRoots = "&javaFileListRoots";
	static final String javaFileRenameTo = "&javaFileRenameTo";
	static final String javaFileSetLastModified = "&javaFileSetLastModified";
	static final String javaFileSetReadOnly = "&javaFileSetReadOnly";
	
//	static final String javaFileSetReadOnly = "&javaFileMakeDir";
//	static final String javaFileSetReadOnly = "&javaFileMakeDirs";
		
	static final String newFileFilter = "&newFileFilter";
	static final String isfilefilter = "-isfilefilter";
	static final String isFileFilter = "&isFileFilter";

	static final String inetAddressByName = "&inetAddressByName";
	static final String inetAddressByAddress = "&inetAddressByAddress";
	static final String isinetaddress = "-isinetaddress";
	static final String isInetAddress = "&isInetAddress";
	static final String inetAddressGetAddress = "&inetAddressGetAddress";
	
	public UtilitiesBridge() {}
	
	static { // add Predicate keywords
		ParserConfig.addKeyword(isjavafile);
		ParserConfig.addKeyword(javafileexists);
		ParserConfig.addKeyword(isfilefilter);
		
		ParserConfig.addKeyword(isinetaddress);

		ParserConfig.addKeyword("-istimer");
	}
		
	public boolean scriptLoaded(ScriptInstance script)
	{
		Hashtable environment = script.getScriptEnvironment().getEnvironment();
		
		JavaFile javaFile = new JavaFile();

		environment.put(newFileFilter, javaFile);
		environment.put(newJavaFile, javaFile);
		environment.put(isjavafile, javaFile);
		environment.put(isJavaFile, javaFile);
		environment.put(javafileexists, javaFile);
		environment.put(javaFileExists, javaFile);
		environment.put(javaFileLength, javaFile);
		environment.put(javaFileGetName, javaFile);
		environment.put(javaFileIsDir, javaFile);
		environment.put(javaFileIsFile, javaFile);
		environment.put(javaFileCanRead, javaFile);
		environment.put(javaFileCanWrite, javaFile);
		environment.put(javaFileIsHidden, javaFile);
		environment.put(javaFileIsAbsolute, javaFile);
		environment.put(javaFileLastModified, javaFile);
		environment.put(javaFileGetPath, javaFile);
		environment.put(javaFileGetParent, javaFile);
		environment.put(javaFileGetAbsolutePath, javaFile);
		environment.put(javaFileGetCanonicalPath, javaFile);
		environment.put(javaFileGetParentFile, javaFile);
		environment.put(javaFileGetAbsoluteFile, javaFile);
		environment.put(javaFileGetCanonicalFile, javaFile);
		environment.put(javaFileList, javaFile);
		environment.put(javaFileListFiles, javaFile);
		environment.put(javaFileListRoots, javaFile);
		environment.put(javaFileRenameTo, javaFile);
		environment.put(javaFileSetLastModified, javaFile);
		environment.put(javaFileSetReadOnly, javaFile);
		
		/*JavaFileFilter javaFileFilter = new JavaFileFilter();
		environment.put(newFileFilter, javaFileFilter);
		environment.put(isfilefilter, javaFileFilter);
		environment.put(isFileFilter, javaFileFilter);
		*/		
		environment.put(newFileFilter, javaFile);
		environment.put(isfilefilter, javaFile);
		environment.put(isFileFilter, javaFile);


		JavaInetAddress inetAddress = new JavaInetAddress();
		environment.put(inetAddressByName, inetAddress);
		environment.put(inetAddressByAddress, inetAddress);
		environment.put(isinetaddress, inetAddress);
		environment.put(isInetAddress, inetAddress);
		environment.put(inetAddressGetAddress, inetAddress);		
		
		JavaProperties javaProperties = new JavaProperties();
		environment.put("&properties",javaProperties );
		environment.put("&loadProperties", javaProperties );
		environment.put("&storeProperties", javaProperties );
		environment.put("asProperties",javaProperties );
		
		JavaTimer javaTimer = new JavaTimer();
		environment.put("-istimer",javaTimer );
		environment.put("&addTimer",javaTimer );
		environment.put("&stopTimer", javaTimer );
		environment.put("&isTimer", javaTimer );
		
		ByteArray byteArray = new ByteArray();
		environment.put("&isByteArray", byteArray );
		environment.put("&toByteArray", byteArray );
		environment.put("&fromByteArray", byteArray );
		
		return true;
	}
	
	public boolean scriptUnloaded(ScriptInstance script)
	{
		return true;
	}
	
	
	/* FILE STUFF */
		
	private static class JavaFile implements Predicate, Function
	{
		public boolean decide(String name, ScriptInstance script, Stack args)
		{
			Object obj = BridgeUtilities.getObject( args );
			if ( name.equals(isjavafile) )
			{
				return ( obj instanceof File );
			}
			else if ( name.equals(javafileexists) )
			{
				return ( obj instanceof File && ((File) obj).exists() );
			}
			else if ( name.equals(isfilefilter) )
			{
				return ( obj instanceof ScriptedFilter );
			}
			return false;
		}
				
		public Scalar evaluate(String name, ScriptInstance script, Stack args)
		{
		/*	if ( name.equals(newJavaFile) )
			{
				String str = BridgeUtilities.getString( args, "" );
				if ( !str.equals("") )
				{
					File file = new File(str);
					return SleepUtils.getScalar( file );
				}
			} */
			if ( name.equals(newJavaFile) )
			{
				if ( args.size() == 1 )
				{
					String str = BridgeUtilities.getString( args, "" );
					if ( !str.equals("") )
					{
						return SleepUtils.getScalar( new File(str) );
					}
				}
				else if ( args.size() == 2 )
				{
					Object obj = BridgeUtilities.getObject( args );
					String str = BridgeUtilities.getString( args, "" );
					if ( obj instanceof File )
					{
						return SleepUtils.getScalar( new File( ((File) obj), str) );
					}
					else if ( obj instanceof String )
					{
						return SleepUtils.getScalar( new File(((String) obj), str) );
					}
				}
				return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(isJavaFile) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					return SleepUtils.getScalar( 1 );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals( newFileFilter ) )
			{
				SleepClosure func = BridgeUtilities.getFunction(args, script);
				if ( func != null )
				{
					return SleepUtils.getScalar( new ScriptedFilter(script,func, BridgeUtilities.getString(args, "scriptedfilter") ) );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals( isFileFilter ) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof ScriptedFilter )
					return SleepUtils.getScalar( 1 );
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileExists) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File && ((File) obj).exists() )
				{
					return SleepUtils.getScalar( 1 );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileLength) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					return SleepUtils.getScalar( ((File) obj).length() );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileLastModified) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					return SleepUtils.getScalar( ((File) obj).lastModified() );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileGetName) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					return SleepUtils.getScalar( ((File) obj).getName() );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileIsDir) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File && ((File) obj).isDirectory() )
				{
					return SleepUtils.getScalar( 1 );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileIsFile) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File && ((File) obj).isFile() )
				{
					return SleepUtils.getScalar( 1 );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileCanRead) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File && ((File) obj).canRead() )
				{
					return SleepUtils.getScalar( 1 );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileCanWrite) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File && ((File) obj).canWrite() )
				{
					return SleepUtils.getScalar( 1 );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileIsHidden) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File && ((File) obj).isHidden() )
				{
					return SleepUtils.getScalar( 1 );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileIsAbsolute) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File && ((File) obj).isAbsolute() )
				{
					return SleepUtils.getScalar( 1 );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileGetPath) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					return SleepUtils.getScalar( ((File) obj).getPath() );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileGetParent) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					return SleepUtils.getScalar( ((File) obj).getParent() );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileGetAbsolutePath) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					return SleepUtils.getScalar( ((File) obj).getAbsolutePath() );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileGetCanonicalPath) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					String canonicalPath = "";
					try
					{
						canonicalPath = ((File) obj).getCanonicalPath();
					}
					catch ( IOException e )
					{
						script.getScriptEnvironment().flagError( e.toString() );
						return SleepUtils.getEmptyScalar();
					}
					return SleepUtils.getScalar( canonicalPath );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileGetParentFile) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					return SleepUtils.getScalar( ((File) obj).getParentFile() );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileGetAbsoluteFile) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					return SleepUtils.getScalar( ((File) obj).getAbsoluteFile() );
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileGetCanonicalFile) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					File canonicalFile = null;
					try
					{
						canonicalFile = ((File) obj).getCanonicalFile();
					}
					catch ( IOException e )
					{
						script.getScriptEnvironment().flagError( e.toString() );
						return SleepUtils.getEmptyScalar();
					}
					return SleepUtils.getScalar( canonicalFile );
				}
				else return SleepUtils.getEmptyScalar();
			}
			// list functions
			else if ( name.equals(javaFileList) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					File file = (File) obj;
					Object obj2 = BridgeUtilities.getObject( args );
					String[] filenames = null;
					if ( obj2 == null )
						filenames = file.list();
					else if ( obj2 instanceof ScriptedFilter )
						filenames = file.list( (java.io.FilenameFilter) obj2 );
					else
						filenames = file.list();
										
					Scalar result = SleepUtils.getArrayScalar(); 
					if ( filenames != null && filenames.length > 0 )
					{
						for ( int i=filenames.length-1; i>=0; i-- )
						{
							result.getArray().push( SleepUtils.getScalar( filenames[i] ) );
						}
					}
					return result;
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileListFiles) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					File file = (File) obj;
					Object obj2 = BridgeUtilities.getObject( args );
					File[] files = null;
					if ( obj2 == null )
						files = file.listFiles();
					else if ( obj2 instanceof ScriptedFilter )
						files = file.listFiles( (java.io.FilenameFilter) obj2 );
					else
						files = file.listFiles();
										
					Scalar result = SleepUtils.getArrayScalar(); 
					if ( files != null && files.length > 0 )
					{
						for ( int i=files.length-1; i>=0; i-- )
						{
							result.getArray().push( SleepUtils.getScalar( files[i] ) );
						}
					}
					return result;
				}
				else return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileListRoots) )
			{
				File[] roots = File.listRoots();
									
				Scalar result = SleepUtils.getArrayScalar(); 
				if ( roots != null && roots.length > 0 )
				{
					for ( int i=roots.length-1; i>=0; i-- )
					{
						result.getArray().push( SleepUtils.getScalar( roots[i] ) );
					}
				}
				return result;
			}
			else if ( name.equals(javaFileRenameTo) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					Object obj2 = BridgeUtilities.getObject( args );
					if ( obj2 instanceof File )
					{
						if ( ((File) obj).renameTo( (File) obj2 ) )
							return SleepUtils.getScalar( 1 );
					}
				}
				return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileSetLastModified) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					long time = BridgeUtilities.getLong( args );
					if ( ((File) obj).setLastModified( time ) )
						return SleepUtils.getScalar( 1 );
				}
				return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(javaFileSetReadOnly) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof File )
				{
					if ( ((File) obj).setReadOnly() )
						return SleepUtils.getScalar( 1 );
				}
				return SleepUtils.getEmptyScalar();
			}
			return SleepUtils.getEmptyScalar();
		}
		
		private static class ScriptedFilter extends javax.swing.filechooser.FileFilter implements java.io.FilenameFilter
		{
			private ScriptInstance script;
			private SleepClosure function;
			private String description;

			ScriptedFilter( ScriptInstance si, SleepClosure func, String desc )
			{
				script = si;
				function = func;
				description = desc;
			}
			
			public boolean accept(File dir, String name)
			{
				return accept( new File( dir, name ) );
			}

			public boolean accept(File file)
			{
				Stack args = new Stack();
				args.push( SleepUtils.getScalar(file) );
				Scalar result = function.callClosure(description, script, args);
				if ( result.intValue() == 1 )
					return true;
				return false;
			}
			
			public String getDescription()
			{
				return description;
			}
		}
	}

/*	
	private static class JavaFileFilter implements Predicate, Function
	{
		public boolean decide(String name, ScriptInstance script, Stack args)
		{
			Object obj = BridgeUtilities.getObject( args );
			return ( obj instanceof ScriptedFilter );
		}
		
		public Scalar evaluate(String name, ScriptInstance script, Stack args)
		{
			if ( name.equals( newFileFilter ) )
			{
				SleepClosure func = BridgeUtilities.getFunction(args, script);
				if ( func != null )
				{
					return SleepUtils.getScalar( new ScriptedFilter(script,func, BridgeUtilities.getString(args, "ScriptedFilter") ) );
				}
			}
			else if ( name.equals( isFileFilter ) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof ScriptedFilter )
					return SleepUtils.getScalar( 1 );
			}
			return SleepUtils.getEmptyScalar();
		}
		
		private static class ScriptedFilter extends javax.swing.filechooser.FileFilter implements java.io.FilenameFilter
		{
			private ScriptInstance script;
			private SleepClosure function;
			private String description;

			ScriptedFilter( ScriptInstance si, SleepClosure func, String desc )
			{
				script = si;
				function = func;
				description = desc;
			}
			
			public boolean accept(File dir, String name)
			{
				return accept( new File( dir, name ) );
			}

			public boolean accept(File file)
			{
				Stack args = new Stack();
				args.push( SleepUtils.getScalar(file) );
				Scalar result = function.callClosure("scriptedfilter", script, args);
				if ( result.intValue() == 1 )
					return true;
				return false;
			}
			
			public String getDescription()
			{
				return description;
			}
		}
	}
*/
	/* INETADDRESS STUFF */
	
	private static class JavaInetAddress implements Predicate, Function
	{	
		public boolean decide(String name, ScriptInstance script, Stack args)
		{
			if ( name.equals(isinetaddress) )
			{
				Object obj = BridgeUtilities.getObject( args );
				return ( obj instanceof InetAddress );
			}
			return false;
		}
		
		public Scalar evaluate(String name, ScriptInstance script, Stack args)
		{
			if ( name.equals(inetAddressByName) )
			{
				String str = BridgeUtilities.getString( args, "" );
				if ( !str.equals("") )
				{
					InetAddress address = null;
					try
					{
						address = InetAddress.getByName(str);
					}
					catch ( UnknownHostException e )
					{
						script.getScriptEnvironment().flagError( e.toString() );
					}
					if ( address != null )
					{
						/*Scalar result = SleepUtils.getScalar();
						result.setValue( address );
						return result;*/
						return SleepUtils.getScalar( address );
					}
				}
			}
			if ( name.equals(inetAddressByAddress) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj != null && obj instanceof byte[] )
				{
					InetAddress address = null;
					try
					{
						address = InetAddress.getByAddress( (byte[]) obj );
					}
					catch ( UnknownHostException e )
					{
						script.getScriptEnvironment().flagError( e.toString() );
					}
					if ( address != null )
					{
						return SleepUtils.getScalar( address );
					}
				}
				else if ( obj != null && obj instanceof ScalarArray )
				{
					ScalarArray arr = (ScalarArray) obj;
					byte[] bytes = new byte[arr.size()];
					int count = 0;
					Iterator iter = arr.scalarIterator();
					while (iter.hasNext())
					{
						bytes[count++] = new Integer(((Scalar)iter.next()).intValue()).byteValue();
					}
					InetAddress address = null;
					try
					{
						address = InetAddress.getByAddress( bytes );
					}
					catch ( UnknownHostException e )
					{
						script.getScriptEnvironment().flagError( e.toString() );
					}
					if ( address != null )
					{
						return SleepUtils.getScalar( address );
					}
				}
			}
			else if ( name.equals(isInetAddress) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof InetAddress )
				{
					return SleepUtils.getScalar( 1 );
				}
				return SleepUtils.getEmptyScalar();
			}
			else if ( name.equals(inetAddressGetAddress) )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof InetAddress )
				{
					return SleepUtils.getScalar( ((InetAddress) obj).getAddress() );
				}
				return SleepUtils.getEmptyScalar();
			}
			return SleepUtils.getEmptyScalar();
		}
	}

/*	
	private static class IsInetAddress implements Predicate, Function
	{
		public boolean decide(String name, ScriptInstance script, Stack args)
		{
			Object obj = BridgeUtilities.getObject( args );
			return ( obj instanceof InetAddress );
		}
		
		
		public Scalar evaluate(String name, ScriptInstance script, Stack args)
		{
			Object obj = BridgeUtilities.getObject( args );
			if ( obj instanceof InetAddress )
			{
				return SleepUtils.getScalar( 1 );
			}
			return SleepUtils.getEmptyScalar();
		}
	}
*/

	private static class ByteArray implements Function //, Predicate
	{	
/*		public boolean decide(String name, ScriptInstance script, Stack args)
		{
			if ( name.equals(isinetaddress) )
			{
				Object obj = BridgeUtilities.getObject( args );
				return ( obj instanceof InetAddress );
			}
			return false;
		}
*/		
		public Scalar evaluate(String name, ScriptInstance script, Stack args)
		{
			if ( name.equals("&isByteArray") )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof byte[] )
					return SleepUtils.getScalar(1);
			}
			else if ( name.equals("&toByteArray") )
			{
				ScalarArray arr = BridgeUtilities.getArray( args );
				if ( arr != null && arr.size() > 0 )
				{
					byte[] bytes = new byte[arr.size()];
					int count = 0;
					Iterator iter = arr.scalarIterator();
					while (iter.hasNext())
					{
						bytes[count++] = new Integer(((Scalar)iter.next()).intValue()).byteValue();
					}
					return SleepUtils.getScalar( bytes );
				}
			}
			else if ( name.equals("&fromByteArray") )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof byte[] )
				{
					byte[] bytes = (byte[]) obj;
					Scalar result = SleepUtils.getArrayScalar(); 
					//Scalar result = SleepUtils.getArrayScalar();           
					for ( int i=0; i<bytes.length; i++ )
					{
						result.getArray().push( SleepUtils.getScalar( new Byte(bytes[i]).intValue()) );
					}
					return result;
				}
			}
			return SleepUtils.getEmptyScalar();
		}
	}

	private static class JavaProperties implements Function
	{
		public Scalar evaluate(String name, ScriptInstance script, Stack args)
		{
			if ( name.equals("&loadProperties") )
			{
				String path = BridgeUtilities.getString( args, "" );
				Properties properties = new Properties();
				FileInputStream in = null;
				try
				{
					in = new FileInputStream( path );
					properties.load( in );
				}
				catch (IOException ex)
				{
					script.getScriptEnvironment().flagError( ex.toString());
				}
				finally {
					if ( in != null ) {
						try { 
							in.close();
						} catch ( IOException ignore ) {}
					}
				}


				Enumeration en = properties.propertyNames();
				Stack stack = new Stack();
				
				while ( en.hasMoreElements() )
				{ // KeyValuePair(Scalar _key, Scalar _value)
					String key = (String) en.nextElement();
					String value = (String) properties.getProperty( key );
					KeyValuePair kvp = new KeyValuePair( SleepUtils.getScalar(key), SleepUtils.getScalar(value) );
					stack.push( SleepUtils.getScalar( kvp ) );
					//stack.push( SleepUtils.getScalar( key + "=" + value ) );
				}
				
				Scalar value = SleepUtils.getHashScalar();
	           
				while (!stack.isEmpty())
				{
					KeyValuePair kvp = BridgeUtilities.getKeyValuePair(stack);
	 
					Scalar blah = value.getHash().getAt(kvp.getKey());
					blah.setValue(kvp.getValue());
				}

				return value;
			}
			else if ( name.equals("&properties") )
			{
				Scalar value = SleepUtils.getHashScalar();
				while (!args.isEmpty())
				{
					KeyValuePair kvp = getKeyValuePair(args);
					Scalar blah = value.getHash().getAt(kvp.getKey());
					blah.setValue(kvp.getValue());
				}
				return value;
			}
			else if ( name.equals("&asProperties") )
			{
				ScalarHash sleepHash = BridgeUtilities.getHash( args );
				if ( sleepHash != null )
					return SleepUtils.getScalar( sleepHashToProperties( sleepHash ) );
			}
			else if ( name.equals("&storeProperties") )
			{
				Scalar result = SleepUtils.getEmptyScalar();

				ScalarHash sleepHash = BridgeUtilities.getHash( args );
				
				String path = BridgeUtilities.getString( args, "" );
				if ( path.equals("") )
					throw new IllegalArgumentException( name + ": properties filename missing" );
				
				String description = "stored by properties extension for sleep";
				if ( args.size() > 0 )
					description = BridgeUtilities.getString( args, description );
					
				Properties properties = sleepHashToProperties( sleepHash );
				FileOutputStream out = null;
				try
				{
					out = new FileOutputStream( path );
					properties.store( out, description );
					result = SleepUtils.getScalar( 1 ); // sleep true
				}
				catch (IOException ex)
				{
					script.getScriptEnvironment().flagError( ex.toString());
				}
				finally {
					if ( out != null ) {
						try { 
							out.close();
						} catch ( IOException ignore ) {}
					}
				}			
				return result;
			}
			return SleepUtils.getEmptyScalar();
		}
	
		private static KeyValuePair getKeyValuePair(Stack args)
		{
			Scalar temps = BridgeUtilities.getScalar(args);

			Scalar key, value;
	      
			//if (temps.objectValue() != null && temps.objectValue().getClass() == kvpair )
			if (temps.objectValue() != null && temps.objectValue() instanceof KeyValuePair )
			{
				String tmp = clean(((KeyValuePair)temps.objectValue()).getKey().toString());
				return new KeyValuePair( SleepUtils.getScalar( tmp ) , ((KeyValuePair)temps.objectValue()).getValue());
			}
		  
			String temp = temps.toString();

			if (temp.indexOf('=') > -1)
			{
				key   = SleepUtils.getScalar(temp.substring(0, temp.indexOf('=')));
				value = SleepUtils.getScalar(  temp.substring( temp.indexOf('=') + 1, temp.length() ) );
			}
			else
			{
				key   = SleepUtils.getScalar(temp);
				value = SleepUtils.getEmptyScalar();
			}

			return new KeyValuePair(key, value);
		}
	   
		private static String clean( String key )
		{
			String result = key;
			//if ( key.indexOf(".") > -1 )
			//	result = result.replaceAll("\\ ","");
			if ( key.indexOf(" . ") > -1 )
				result = result.replaceAll("\\ \\.\\ ",".");
			if ( key.indexOf("'") > -1 )
				result = result.replaceAll("'","");
			if ( key.indexOf("\"") > -1 )
				result = result.replaceAll("\\\"","");
			return result;
		}

		private static Properties sleepHashToProperties( ScalarHash sleepHash )
		{
			Properties result = new Properties();
			ScalarArray array = sleepHash.keys();
			Iterator iter = array.scalarIterator();
			while ( iter.hasNext() )
			{
				Scalar key = (Scalar) iter.next();
				Scalar value = sleepHash.getAt( key );
				result.put( clean(key.toString()), value.toString() );
				//result.put( key.toString(), value.toString() );
			}
				
			return result;
		}
	}
	
	private static class JavaTimer implements Predicate, Function
	{
		private static Timer timer;
		
		public boolean decide(String name, ScriptInstance script, Stack args)
		{
			Object obj = BridgeUtilities.getObject( args );
			if ( name.equals("-istimer") )
			{
				return ( obj instanceof ScriptedTask );
				//return ( obj instanceof TimerTask );
			}
			return false;
		}
		
		public Scalar evaluate(String name, ScriptInstance script, Stack args)
		{
			if ( name.equals("&addTimer") )
			{
				SleepClosure func = BridgeUtilities.getFunction(args, script);
				long delay = BridgeUtilities.getLong( args, 1 ) * 1000L;
				int repeat = BridgeUtilities.getInt( args, Integer.MAX_VALUE );
				if ( repeat <= 0 )
					repeat = Integer.MAX_VALUE;
				Stack targs = new Stack();
				if ( !args.empty() )
				{
					targs.addAll( args );
				}
				if ( timer == null ) timer = new Timer(true);
				//System.out.println(func);
				ScriptedTask task = new ScriptedTask( script, func, repeat, targs );
				timer.schedule( task, delay, delay );
				return SleepUtils.getScalar( task );
			}
			else if ( name.equals("&stopTimer") )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof ScriptedTask )
				{
					((ScriptedTask) obj).stopTask();
				}
			}
			else if ( name.equals("&isTimer") )
			{
				Object obj = BridgeUtilities.getObject( args );
				if ( obj instanceof ScriptedTask )
					return SleepUtils.getScalar(1);
			}
			return SleepUtils.getEmptyScalar();
		}
		
		private static class ScriptedTask extends TimerTask
		{
			private ScriptInstance script;
			private SleepClosure function;
			private int repeat;
			private Stack arguments;
			
			ScriptedTask( ScriptInstance si, SleepClosure func, int r, Stack args )
			{
				script = si;
				function = func;
				repeat = r;
				arguments = args;
			}
			
			void stopTask()
			{
				repeat = -1;
			}
			
			boolean isStopped()
			{
				return (repeat <= 0);
			}
			
			public void run()
			{
         		if ( repeat <= 0 )
         		{
					function = null;
					arguments = null;
					try {
						cancel();
					} catch ( Exception e ) { /* DO NOTHING */ }
					return;
         		}
         		if ( repeat != Integer.MAX_VALUE )
         			repeat--;
				// SleepClosure.callClosure(String message, ScriptInstance si, Stack locals)
				Stack targs = new Stack();
				if ( !arguments.empty() )
				{
					/*Scalar[] oa = new Scalar[arguments.size()];
					for ( int i=0;i<oa.lenth;i++ )
						oa[i] = SleepUtils.getScalar( arg );*/
					targs.addAll( arguments );
				}
				targs.push( SleepUtils.getScalar(this) );
         		function.callClosure("scriptedtask", script,targs);
			}
		}
	}
	
/*	
	private static class JavaTimer implements Predicate, Function
	{
		public boolean decide(String name, ScriptInstance script, Stack args)
		{
			Object obj = BridgeUtilities.getObject( args );
			if ( name.equals("-istimer") )
			{
				return ( obj instanceof Timer );
			}
			return false;
		}
		
		public Scalar evaluate(String name, ScriptInstance script, Stack args)
		{
			if ( name.equals("&newTimer") )
			{
				boolean daemon = (BridgeUtilities.getInt( args, 1 ) == 1) ? true : false;
				return SleepUtils.getScalar( new Timer(daemon) ); // default run as daemon 
			}
			else
			{
				Object obj = BridgeUtilities.getObject(args);
				if ( obj instanceof Timer )
				{
					Timer timer = (Timer) obj;
					if ( name.equals("&isTimer") )
					{
						return SleepUtils.getScalar(1);
					}
					else if ( name.equals("&cancel") )
					{
						timer.cancel();
					}
					else if ( name.equals("&schedule") )
					{
					}
					else if ( name.equals("&scheduleAtFixedRate") )
					{
					}
				}
			}
			return SleepUtils.getEmptyScalar();
		}
	}
	
	private static class JavaTimerTask implements Predicate, Function
	{
		public boolean decide(String name, ScriptInstance script, Stack args)
		{
			Object obj = BridgeUtilities.getObject( args );
			if ( name.equals(-istimertask) )
			{
				return ( obj instanceof ScriptedTask );
			}
			return false;
		}
		public Scalar evaluate(String name, ScriptInstance script, Stack args)
		{
			if ( name.equals("&newTimerTask") )
			{
				SleepClosure func = BridgeUtilities.getFunction(args, script);
				Stack targs = new Stack();
				if ( !args.empty )
				{
					targs.addAll( args ); // ?
				}
				return SleepUtils.getScalar( new ScriptedTask( func, targs ) );
			}
		}
		private class ScriptedTask extends TimerTask
		{
			SleepClosure function;
			Stack arguments;
			ScriptedTask( SleepClosure func, Stack args )
			{
				function = func;
				arguments = args;
			}
			
			public void run()
			{
				// SleepClosure.callClosure(String message, ScriptInstance si, Stack locals)
         		function.callClosure("scriptedtask", si, arguments);
			}
		}
	}
*/
}
